#    Copyright 2003 Regis Damongeot

#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 
proc refresh_cmd_line {} {
	global total_file_size_f option_udf_ext option_joliet_ext option_rr_ext burn_speed file_list volume_id option_pad burn_type command_line t_session burning_device iso_file space_left_f burn_command option_dvd_compat option_overburn excluded_file_list dvd_size v_create_iso
	if { [catch { exec ps -A | grep growisofs }] != 0 } {
		if { ($burn_type == "burn_dvd") || ($burn_type == "create_iso") } {
			check_volume_id
			if { (([lindex $space_left_f 0] <0 ) || ([lindex $total_file_size_f 0] > 4.377 && $dvd_size == 4589850)) && [lindex $total_file_size_f 1] == "GB" && $option_overburn == "" && $burn_type == "burn_dvd" && $v_create_iso == "no" } {
				#exact maximum size: 4.37721610069. Although it should be oversized because "du" return > real file size due to indirect blocks its undersized to prevent disallowing burning when beleving overburn is needed while its no the case (anyway growisofs check it)
				set command_line "You need to enable overburning if you want to burn all theses files"
				.f_burn.go_button configure -state disabled
			} else {
				#create list containing excluded files and directories prefixed with -m option
				set excluded_file_list_t ""
				foreach i $excluded_file_list {
					append excluded_file_list_t "-m {$i} "
					
				} 
				#if we burn a DVD-Video UDF complient we need to not modify directory with graft points
				if {$option_udf_ext != "-dvd-video" } {
					set command_line "[concat $burn_command $t_session $burning_device $volume_id $option_udf_ext $option_joliet_ext $option_rr_ext $burn_speed $option_dvd_compat $option_overburn $option_pad -graft-points $excluded_file_list_t [file_list_w_modif_dir $file_list]]"
				} else {
					set command_line "[concat $burn_command $t_session $burning_device $volume_id $option_udf_ext $burn_speed $option_dvd_compat $option_overburn $excluded_file_list_t $file_list]"
				}
				#reactive le bouton burn si tt est ok
				if { [.f_burn.go_button cget -state] == "disabled" } { .f_burn.go_button configure -state normal }
			}
		} elseif { $burn_type == "burn_iso" } {
			set command_line "$burn_command $option_dvd_compat $burn_speed $option_overburn $t_session $burning_device=$iso_file"
			if { [.f_burn.go_button cget -state] == "disabled" } { .f_burn.go_button configure -state normal }
		}
	} else { set command_line "growisofs is currently working" }
	if {($t_session == "-M" && $space_left_f != "N/A") || ($t_session == "-use-the-force-luke=tty -Z" && $space_left_f == "N/A") } { refresh_total_file_size }
	return 1
}